/*
 * Copyright (c) 2004,2005 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef __SYS_SUNMEDIA_INTRIN_H
#define __SYS_SUNMEDIA_INTRIN_H

#pragma ident	"@(#)sunmedia_intrin.h 1.4 06/01/20"

#include <sys/pmmintrin.h>

#ifdef __cplusplus
extern "C" {
#endif

/*----------------------------------------------------------
          Sun specific intrinsics
  ----------------------------------------------------------*/

/*----------------------------------------------------------
      Intrinsics available under SSE2 platform 
  ----------------------------------------------------------*/

/*   Integer Load/Store Operations allowing type based alias analysis */
extern __m128i _mm_loadl_epi64_8(char const *p);
extern __m128i _mm_loadl_epi64_16(short const *p);
extern __m128i _mm_loadl_epi64_32(int const *p);
extern __m128i _mm_loadl_epi64_64(long long const *p);
extern __m128i _mm_load_si128_8(char const *p);
extern __m128i _mm_load_si128_16(short const *p);
extern __m128i _mm_load_si128_32(int const *p);
extern __m128i _mm_load_si128_64(long long const *p);
extern __m128i _mm_loadu_si128_8(char const *p);
extern __m128i _mm_loadu_si128_16(short const *p);
extern __m128i _mm_loadu_si128_32(int const *p);
extern __m128i _mm_loadu_si128_64(long long const *p);
extern void _mm_storel_epi64_8(char *p1, __m128i p2);
extern void _mm_storel_epi64_16(short *p1, __m128i p2);
extern void _mm_storel_epi64_32(int *p1, __m128i p2);
extern void _mm_storel_epi64_64(long long *p1, __m128i p2);
extern void _mm_store_si128_8(char *p1, __m128i p2);
extern void _mm_store_si128_16(short *p1, __m128i p2);
extern void _mm_store_si128_32(int *p1, __m128i p2);
extern void _mm_store_si128_64(long long *p1, __m128i p2);
extern void _mm_storeu_si128_8(char *p1, __m128i p2);
extern void _mm_storeu_si128_16(short *p1, __m128i p2);
extern void _mm_storeu_si128_32(int *p1, __m128i p2);
extern void _mm_storeu_si128_64(long long *p1, __m128i p2);

#ifdef __cplusplus
}
#endif

#endif
